Go App Engine packages
Go Protocol Buffer Shell
Latest commit 56d253d Mar 21, 2017 @broady broady committed on GitHub README: update for flex (#61)
The Flex environment does not support the App Engine APIs.

Add a section pointing those people toward the upgrade guide on cloud.google.com.

Retain the existing section about aefix, but remove the suggestion that it's useful with the flexible environment.
Permalink
Failed to load latest commit information.
aetest aetest: add StartupTimeout option (#56) Mar 3, 2017
blobstore Add blobstore package. Jul 2, 2015
capability Update more docs to follow new Managed VM branding. Mar 23, 2016
channel Add missing copyright headers. Aug 25, 2015
cloudsql Update more docs to follow new Managed VM branding. Mar 23, 2016
cmd cmd/aedeploy: deprecate aedeploy (#65) Mar 21, 2017
datastore datastore: fix handling of embedded unexported structs (#58) Mar 7, 2017
delay delay: clarify the purpose of the key in the doc Dec 17, 2016
demos Update more docs to follow new Managed VM branding. Mar 23, 2016
file Remove internal.CallOptions entirely, and use the context's timeout f… Jan 28, 2015
image Remove internal.CallOptions entirely, and use the context's timeout f… Jan 28, 2015
internal internal: adjust memory threshold for API test (#46) Jan 21, 2017
log Add missing copyright headers. Aug 25, 2015
mail Update example code to use current log API. Mar 22, 2015
memcache Normalize namespace and transaction application. May 17, 2016
module Remove internal.CallOptions entirely, and use the context's timeout f… Jan 28, 2015
remote_api remote_api: don't check auth for dev_appserver (#43) Jan 21, 2017
runtime runtime: update RunInBackground doc to include basic scaling. Aug 8, 2016
search search: add PutMulti and DeleteMulti methods. (#44) Jan 21, 2017
socket Update more docs to follow new Managed VM branding. Mar 23, 2016
taskqueue appengine: make all tests run against the classic SDK's goapp Aug 4, 2015
urlfetch Use the context's deadline for urlfetch, and drop urlfetch.Transport'… May 27, 2015
user Accept both the cloud-platform and appengine.apis scopes for the Oct 6, 2015
xmpp Remove internal.CallOptions entirely, and use the context's timeout f… Jan 28, 2015
.travis.yml travis: fix versions and unzip verbosity Sep 27, 2016
CONTRIBUTING.md CONTRIBUTING.md: adds file (#42) Jan 6, 2017
LICENSE Add LICENSE file. Feb 7, 2014
README.md README: update for flex (#61) Mar 21, 2017
appengine.go appengine: Update appengine.Main docstring for AE Standard Oct 21, 2016
appengine_test.go Add missing copyright headers. Aug 25, 2015
appengine_vm.go appengine: introduce appengine.Main() for Standard. Jul 7, 2016
errors.go Remove appengine.IsCapabilityDisabled. Feb 6, 2014
identity.go appengine: name returned parameters on SignBytes to improve documenta… Apr 7, 2015
namespace.go Refactor namespace application so it gets correctly applied implicitly. Jan 4, 2016
namespace_test.go Normalize namespace and transaction application. May 17, 2016
timeout.go Remove internal.CallOptions entirely, and use the context's timeout f… Jan 28, 2015

README.md

Go App Engine packages

Build Status

This repository supports the Go runtime on App Engine standard. It provides APIs for interacting with App Engine services. Its canonical import path is google.golang.org/appengine.

See https://cloud.google.com/appengine/docs/go/ for more information.

File issue reports and feature requests on the GitHub's issue tracker.

Upgrading an App Engine app to the flexible environment

This package does not work on App Engine flexible.

There are many differences between the App Engine standard environment and the flexible environment.

See the documentation on upgrading to the flexible environment.

Directory structure

The top level directory of this repository is the appengine package. It contains the basic APIs (e.g. appengine.NewContext) that apply across APIs. Specific API packages are in subdirectories (e.g. datastore).

There is an internal subdirectory that contains service protocol buffers, plus packages required for connectivity to make API calls. App Engine apps should not directly import any package under internal.

Updating from legacy (import "appengine") packages

If you're currently using the bare appengine packages (that is, not these ones, imported via google.golang.org/appengine), then you can use the aefix tool to help automate an upgrade to these packages.

Run go get google.golang.org/appengine/cmd/aefix to install it.

1. Update import paths

The import paths for App Engine packages are now fully qualified, based at google.golang.org/appengine. You will need to update your code to use import paths starting with that; for instance, code importing appengine/datastore will now need to import google.golang.org/appengine/datastore.

2. Update code using deprecated, removed or modified APIs

Most App Engine services are available with exactly the same API. A few APIs were cleaned up, and there are some differences:

  • appengine.Context has been replaced with the Context type from golang.org/x/net/context.
  • Logging methods that were on appengine.Context are now functions in google.golang.org/appengine/log.
  • appengine.Timeout has been removed. Use context.WithTimeout instead.
  • appengine.Datacenter now takes a context.Context argument.
  • datastore.PropertyLoadSaver has been simplified to use slices in place of channels.
  • delay.Call now returns an error.
  • search.FieldLoadSaver now handles document metadata.
  • urlfetch.Transport no longer has a Deadline field; set a deadline on the context.Context instead.
  • aetest no longer declares its own Context type, and uses the standard one instead.
  • taskqueue.QueueStats no longer takes a maxTasks argument. That argument has been deprecated and unused for a long time.
  • appengine.BackendHostname and appengine.BackendInstance were for the deprecated backends feature. Use appengine.ModuleHostnameand appengine.ModuleName instead.
  • Most of appengine/file and parts of appengine/blobstore are deprecated. Use Google Cloud Storage if the feature you require is not present in the new blobstore package.
  • appengine/socket is not required on App Engine flexible environment / Managed VMs. Use the standard net package instead.